## net.sf.saxon.xom
Class DocumentWrapper

    java.lang.Object
      net.sf.saxon.xom.NodeWrapper
          net.sf.saxon.xom.DocumentWrapper

All Implemented Interfaces:
  javax.xml.transform.Source, PullEvent, DocumentInfo, Item, NodeInfo, SiblingCountingNode, ValueRepresentation, VirtualNode

    public class DocumentWrapper

extends NodeWrapper
implements DocumentInfo

The root node of an XPath tree. (Or equivalently, the tree itself).

This class is used not only for a document, but also for the root of a document-less tree fragment.

Author:
  Michael H. Kay, Wolfgang Hoschek (ported net.sf.saxon.jdom to XOM)

Field Summary
`protected java.lang.String` `baseURI`
`protected Configuration` `config`
`protected int` `documentNumber`

Fields inherited from class net.sf.saxon.xom.NodeWrapper
`docWrapper, index, node, nodeKind`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DocumentWrapper(nu.xom.Node root, java.lang.String baseURI, Configuration config)` Create a Saxon wrapper for a XOM root node

Method Summary
`Configuration` `getConfiguration()` Get the configuration previously set using setConfiguration
`int` `getDocumentNumber()` Get the unique document number for this document (the number is unique for all documents within a NamePool)
`NamePool` `getNamePool()` Get the name pool used for the names in this document
`java.lang.String[]` `getUnparsedEntity(java.lang.String name)` Get the unparsed entity with a given name
`java.util.Iterator` `getUnparsedEntityNames()` Get the list of unparsed entities defined in this document
`NodeInfo` `selectID(java.lang.String id)` Get the element with a given ID, if any
`void` `setConfiguration(Configuration config)` Set the configuration, which defines the name pool used for all names in this document.
`NodeInfo` `wrap(nu.xom.Node node)` Wrap a node in the XOM document.

Methods inherited from class net.sf.saxon.xom.NodeWrapper

`atomize, compareOrder, copy, delete, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNodeKind, getParent, getPrefix, getRoot, getSiblingPosition, getStringValue, getStringValueCS, getSystemId, getTypeAnnotation, getTypedValue, getUnderlyingNode, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis, makeWrapper, makeWrapper, setSystemId`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo

`atomize, compareOrder, copy, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getDeclaredNamespaces, getDisplayName, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNodeKind, getParent, getPrefix, getRoot, getStringValue, getSystemId, getTypeAnnotation, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

Methods inherited from interface javax.xml.transform.Source
`setSystemId`

Methods inherited from interface net.sf.saxon.om.Item
`getStringValueCS, getTypedValue`

Field Detail

### config

    protected Configuration config

### baseURI

    protected java.lang.String baseURI

### documentNumber

    protected int documentNumber

Constructor Detail

### DocumentWrapper

    public DocumentWrapper(nu.xom.Node root,
                           java.lang.String baseURI,
                           Configuration config)

  Create a Saxon wrapper for a XOM root node

  Parameters:
    `root` - The XOM root node
    `baseURI` - The base URI for all the nodes in the tree
    `config` - The configuration which defines the name pool used for all names in this tree

Method Detail

### wrap

    public NodeInfo wrap(nu.xom.Node node)

  Wrap a node in the XOM document.

  Parameters:
    `node` - The node to be wrapped. This must be a node in the same document (the system does not check for this).
  Returns:
    the wrapping NodeInfo object

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the configuration, which defines the name pool used for all names in this document. This is always called after a new document has been created. The implementation must register the name pool with the document, so that it can be retrieved using getNamePool(). It must also call NamePool.allocateDocumentNumber(), and return the relevant document number when getDocumentNumber() is subsequently called.

  Parameters:
    `config` - The configuration to be used

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration previously set using setConfiguration

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Overrides:
    `getConfiguration` in class `NodeWrapper`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the name pool used for the names in this document

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Overrides:
    `getNamePool` in class `NodeWrapper`
  Returns:
    the name pool in which all the names used in this document are registered

### getDocumentNumber

    public int getDocumentNumber()

  Get the unique document number for this document (the number is unique for all documents within a NamePool)

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Overrides:
    `getDocumentNumber` in class `NodeWrapper`
  Returns:
    the unique number identifying this document within the name pool

### selectID

    public NodeInfo selectID(java.lang.String id)

  Get the element with a given ID, if any

  Specified by:
    `selectID` in interface `DocumentInfo`
  Parameters:
    `id` - the required ID value
  Returns:
    the element with the given ID, or null if there is no such ID present (or if the parser has not notified attributes as being of type ID).

### getUnparsedEntityNames

    public java.util.Iterator getUnparsedEntityNames()

  Get the list of unparsed entities defined in this document

  Specified by:
    `getUnparsedEntityNames` in interface `DocumentInfo`
  Returns:
    an Iterator, whose items are of type String, containing the names of all unparsed entities defined in this document. If there are no unparsed entities or if the information is not available then an empty iterator is returned

### getUnparsedEntity

    public java.lang.String[] getUnparsedEntity(java.lang.String name)

  Get the unparsed entity with a given name

  Specified by:
    `getUnparsedEntity` in interface `DocumentInfo`
  Parameters:
    `name` - the name of the entity
  Returns:
    null: XOM does not provide access to unparsed entities

Copyright (c) Saxonica Limited. All rights reserved.